/*
   Handles the Intuition IntuiText structure
*/

#include "header/sb.h"

extern int level;         /* recursion level */


/*
  PrIText

  Put up the data for an IntuiText structure
*/

PrIText (string, itext)
char *string;
struct IntuiText *itext;
{
static struct StructData structdata [] =
  {
     { "-FrontPen",     "UBYTE",               PRUBYTE,    BYTESIZE},
     { "-BackPen",      "UBYTE",               PRUBYTE,    BYTESIZE},
     { "-DrawMode",     "UBYTE",               PRUBYTE,    INTSIZE },
     { "-LeftEdge",     "SHORT",               PRINT,      INTSIZE },
     { "-TopEdge",      "SHORT",               PRINT,      INTSIZE },
     { " ITextFont",    "struct TextAttr *",   PRPTR,      PTRSIZE },
     { " IText",        "UBYTE *",             PRSTRING,   PTRSIZE },
     { " NextText",     "struct IntuiText *",  PRPTR,      PTRSIZE }
  };
int i, sum;
int choice = -1;

   level++;

   while (choice)
   {
      sum = SetOptionText(string, structdata, (APTR)itext, DATASIZE, 0);

      switch (choice = GetChoice(DATASIZE))
      {
         case 6:
            if (itext->ITextFont)
               PrTextAttr("The font attributes for this IntuiText",
                  itext->ITextFont);
            break;
         case 7:
            if (itext->IText)
               PrString("The text for this IntuiText", itext->IText);
            break;
         case 8:
            if (itext->NextText)
               PrIText("The next IntuiText", itext->NextText);
            break;
      }
   }
   level--;
}
